
# HISTOGRAM according to Ricordi
# the same as in Meranie.exe
def HistRic(DiaIsl):
    N70 = 0
    N6570 = 0
    N6065 = 0
    N5560 = 0
    N5055 = 0
    N4550 = 0 
    N4045 = 0
    N3540 = 0
    N3035 = 0
    N2530 = 0
    N2025 = 0
    N1520 = 0
    N1015 = 0
    N0510 = 0
    N05 = 0
    for ar in range(0,len(DiaIsl)):
     if DiaIsl[ar] <= 50:
      N05 = N05 + 1
     elif 50 < DiaIsl[ar] <= 100:
      N0510 = N0510 + 1
     elif 100 < DiaIsl[ar] <= 150:
      N1015 = N1015 + 1
     elif 150 < DiaIsl[ar] <= 200:
      N1520 = N1520 + 1
     elif 200 < DiaIsl[ar] <= 250:
      N2025 = N2025 + 1
     elif 250 < DiaIsl[ar] <= 300:
      N2530 = N2530 + 1
     elif 300 < DiaIsl[ar] <= 350:
      N3035 = N3035 + 1
     elif 350 < DiaIsl[ar] <= 400:
      N3540 = N3540 + 1   
     elif 400 < DiaIsl[ar] <= 450:
      N4045 = N4045 + 1
     elif 450 < DiaIsl[ar] <= 500:
      N4550 = N4550 + 1
     elif 500 < DiaIsl[ar] <= 550:
      N5055 = N5055 + 1
     elif 550 < DiaIsl[ar] <= 600:
      N5560 = N5560 + 1
     elif 600 < DiaIsl[ar] <= 650:
      N6065 = N6065 + 1
     elif 650 < DiaIsl[ar] <= 700:
      N6570 = N6570 + 1
     elif DiaIsl[ar] > 700:
      N70 = N70 + 1
    HistRicordi = [N05,N0510,N1015,N1520,N2025,N2530,N3035,N3540,N4045,N4550,N5055,N5560,N6065,N6570,N70]
    return HistRicordi

    
###################################################################################

def ParamEval(a,b,areas,dXpixNorm,optMagnif):
    import math
    
    AreaEllip = [0]*len(b)
    VolumeEllip = [0]*len(b)
    VolumeSph = [0]*len(b)
    VolumeSp150 = [0]*len(b)
    NoIslet = [0]*len(b)
    Lavg = [0]*len(b)
    aScale = [0]*len(b)
    bScale = [0]*len(b)
    RadIsl = [0]*len(areas) 
    DiaIsl = [0]*len(areas) 
    areasMikro = [0]*len(areas)
    VolumeEllipuL = [0]*len(areas)
    VolumeSphuL = [0]*len(areas)

# PARAMETERS OF ACQUISITION DEVICE
    dXpixNorm = dXpixNorm/optMagnif              # pixel size of microscope camera at sample plane, [um]
    SpixNorm = math.pow(dXpixNorm,2)                  # pixel area   
   
# AREA AND VOLUME OF ELLIPSE
    for i in range(0,len(areas)):
      AreaEllip[i] = (a[i]/2)*(b[i]/2)*math.pi*SpixNorm     # area of ellipses fitted on islets, in real scale
      Lavg[i] = dXpixNorm*(a[i]+b[i])/2                     # average length of axis, in real scale
      VolumeEllip[i] = (float(4)/3)*math.pow(dXpixNorm,3)*(a[i]/2)*(b[i]/2)*(b[i]/2)*math.pi  # volume of ellipse, in real scale um^3
      VolumeEllipuL[i] = (float(4)/3)*math.pow(dXpixNorm/1000,3)*(a[i]/2)*(b[i]/2)*(b[i]/2)*math.pi  # volume of ellipse, in uL
      VolumeSp150 = (float(4)/3)*math.pow(150/2,3)*math.pi
      aScale[i] = a[i]*dXpixNorm                            # ellipse axis in real scale [um]
      bScale[i] = b[i]*dXpixNorm  
      NoIslet[i] = i+1

# PARAMETER OF SPHERE
    for j in range(0, len(areas)):
     areasMikro[j] = areas[j]*SpixNorm              # islet area size, in real scale
     RadIsl[j] = math.sqrt(areasMikro[j]/math.pi)   # radius of islet, we consider circle shape
     DiaIsl[j] = 2*RadIsl[j]                        # diameter of islets
    for m in range(0, len(RadIsl)):
      VolumeSph[m] = (float(4)/3)*math.pi*math.pow(RadIsl[m],3)    # volume evaluation, we consider sphere, in um^3
      VolumeSphuL[m] = (float(4)/3)*math.pi*math.pow(RadIsl[m]/1000,3)    # volume evaluation, we consider sphere, in uL

    SumVolumeEll = sum(VolumeEllipuL)   # sum of volumes in uL
    SumVolumeSph = sum(VolumeSphuL)     # sum of volumes in uL
    SumAreaPixel = sum(areasMikro)
    SumAreaEllip = sum(AreaEllip)
    return aScale,bScale,areasMikro,AreaEllip,VolumeSph,VolumeSp150,VolumeEllip,DiaIsl,SumAreaPixel,SumAreaEllip,SumVolumeSph,SumVolumeEll,Lavg,NoIslet

###################################################################################

def ParamEvalHist(HistRicordi,HistRicLavg,areas,VolumeEllip,VolumeSp150,VolumeSph):

      IsletRangePlot = [0,50,100,150,200,250,300,350,400,450,500,550,600,650,700]
#IsletRangePlot = [25,75,125,175,225,275,325,375]
      IsletRange = ['0-50','50-100','100-150','150-200','200-250','250-300','300-350','350-inf']
      IEQconvFact = [0,0.167,0.648,1.685,3.500,6.315,10.352,15.833,23,32,43,57,73,92,113]   # islet conversion factor
      IEQperRange = [0]*len(HistRicordi)
      IEQperRangeLavg = [0]*len(HistRicordi)
      for ieq in range(0,len(HistRicordi)):
         IEQperRange[ieq] = HistRicordi[ieq]*IEQconvFact[ieq]        # IEQ evaluated from sphere
         IEQperRangeLavg[ieq] = HistRicLavg[ieq]*IEQconvFact[ieq]    # diameter is computed as average length of ellipse axes

      IEQ_cal = sum(IEQperRangeLavg)
#print IEQ_cal
      TotIEQ = sum(IEQperRange)

      IEQperRangeEll = [0]*len(areas)
      IEQperRangeSph = [0]*len(areas)
      for ieq in range(0,len(areas)):
        IEQperRangeEll[ieq] = VolumeEllip[ieq]/VolumeSp150
        IEQperRangeSph[ieq] = VolumeSph[ieq]/VolumeSp150          # ratio between sphere and sphere d = 150 um

      TotIEQEllip = sum(IEQperRangeEll)   # total IEQ from ellipses
      return IsletRangePlot,IEQconvFact,IEQperRange,IEQperRangeLavg,IEQ_cal,TotIEQ,IEQperRangeEll,IEQperRangeSph,TotIEQEllip